#include <U8g2lib.h>
#include <Wire.h>

U8G2_SSD1306_128X64_NONAME_F_HW_I2C display(U8G2_R0,U8X8_PIN_NONE);

String rx;
byte id_pot=0;
int srv[4]={90,90,90,90};
int joy[4]={0,0,0,0};

void setup() {
  Serial.begin(9600);
  pinMode(2,OUTPUT);
  digitalWrite(2,0);
  display.begin();
  display.setFont(u8g2_font_9x18_tf);
  display.setFontRefHeightExtendedText();
  display.setDrawColor(1);
  display.setFontPosTop();
  display.setFontDirection(0);
  while (Serial.read()!=10);
}

void loop() {
  while (!Serial.available());
  delay(100);
  while (Serial.available())
  {
    char c=Serial.read();
    if ((c>='0') && (c<='9'))
      rx+=c;
    else
    if ((c=='-') && (rx==""))
      rx="-";
    else
    {
      if ((rx!="") && (id_pot<4))
      {
        joy[id_pot++]=rx.toInt();
        rx="";
      }
      if (c==10)
      {
        id_pot=0;
        rx="";
      }
    }
  }
  display.clearBuffer();
  for (int i=0; i<4; i++)
  {
    srv[i]+=joy[i];
    if (srv[i]<0) srv[i]=0;
    if (srv[i]>180) srv[i]=180;
    char s[20];
    sprintf(s,"A%d %4d %4d",i,joy[i],srv[i]);
    display.drawStr(10,i*16,s);
  }
  display.sendBuffer();
}
